//======================================================================
// 
//  Filemon.h
//
//  Copyright (C) 1996 Mark Russinovich and Bryce Cogswell
//
//  This module contains the PRIVATE (driver-only) definitions for the
//  code that implements the mono device driver.
//
//======================================================================

// A structure representing the instance information associated with
// a particular device
typedef struct _DEVICE_EXTENSION
{
    ULONG  StateVariable;
} DEVICE_EXTENSION, *PDEVICE_EXTENSION;

// Structure for device specific data that keeps track of what
// drive and what filesystem device are hooked 
typedef struct {
   PDEVICE_OBJECT	FileSystem;
   unsigned		LogicalDrive;
} HOOK_EXTENSION, *PHOOK_EXTENSION;			

// Structure for our name hash table
typedef struct _nameentry {
   PFILE_OBJECT		FileObject;
   PCHAR		FullPathName;
   struct _nameentry 	*Next;
} HASH_ENTRY, *PHASH_ENTRY;

// Structure for keeping linked lists of output buffers
typedef struct _store {
    ULONG		Len;
    struct _store *	Next;
    char		Data[ MAX_STORE ];
} STORE_BUF, *PSTORE_BUF;

// number of hash buckets
#define NUMHASH		0x100
#define HASHOBJECT(_fileobject)		(((ULONG)_fileobject)>>2)%NUMHASH


// Define the various device type values.  Note that values used by Microsoft
// Corporation are in the range 0-32767, and 32768-65535 are reserved for use
// by customers.
#define FILE_DEVICE_FILEMON	0x00008300

// NT Build numbers
#define NT4B2        1314
#define NT4FINAL     1381




