//======================================================================
// 
// Ioctlcmd.h
//
// Copyright (C) 1996 Mark Russinovich and Bryce Cogswell
//
// Common header file for device driver and GUI. Contains common
// data structure definitions and IOCTL command codes.
//
//======================================================================

// commands that the GUI can send the device driver
enum {
	FILEMON_setdrives	= 1,
	FILEMON_zerostats	= 2,
	FILEMON_getstats	= 3,
	FILEMON_unloadquery	= 4,
};


// format of a data entry
typedef struct {
	ULONG	seq;
	char	text[0];
} ENTRY, *PENTRY;


// define page size for use by GUI
#ifndef PAGE_SIZE
#define PAGE_SIZE 4096
#endif

// an allocation unit size 
#define MAX_STORE	(PAGE_SIZE*16 - 8)

