// DeviceDlg.cpp

#include "stdafx.h"
#include "midixchg.h"
#include "DeviceDlg.h"
#include "midiin.h"
#include "midiout.h"

CDeviceDlg::CDeviceDlg(MidiIn* pMidiIn, MidiOut* pMidiOut)
	: CDialog(IDD_MIDIDEVICES, 0)
{
	m_nOutDevice = -1;
	m_nInDevice = -1;
	m_pMidiIn = pMidiIn;
	m_pMidiOut = pMidiOut;
}
void CDeviceDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_OUTDEVICES, m_OutDevice);
	DDX_Control(pDX, IDC_INDEVICES, m_InDevice);
}
BOOL CDeviceDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	m_pMidiIn->DeviceList(&m_InDevice);
	m_pMidiOut->DeviceList(&m_OutDevice);
	m_InDevice.SetCurSel(m_nInDevice);
	m_OutDevice.SetCurSel(m_nOutDevice);
	return TRUE;
}
void CDeviceDlg::OnOK() 
{
	m_nOutDevice = m_OutDevice.GetCurSel();
	m_nInDevice = m_InDevice.GetCurSel();
	CDialog::OnOK();
}
