// MainFrm.h

#include "midiin.h"
#include "midiout.h"
#include "DeviceDlg.h"

const int nMaxCaptures = 128;

class CMainFrame : public CFrameWnd
{
	CDeviceDlg* m_pCDeviceDlg;
	MidiIn* m_pMidiIn;
	MidiOut* m_pMidiOut;
	int m_nY;
	BOOL m_bReportedEventStream;
	static int m_nPrevNote;
	static int m_nNotesDropped;
	static int m_nTotalNotes;
	static UINT SendEvents(void*);
	static BOOL m_bSending;
	static BOOL m_bReceiving;
	static BOOL m_bPostResults;
	static BOOL m_bReceivingEvents;
	static DWORD m_dwStartTime;
	static DWORD m_dwStopTime;

	void InitializeReceiver();
	void DisplayMessage(const CString& strMsg);
	static void CALLBACK CMainFrame::MidiInProc(
						HMIDIIN hMidiIn,
						UINT wMsg,
						DWORD dwInstance,
						DWORD dwParam1,
						DWORD dwParam2
					   );
protected:
	DECLARE_DYNCREATE(CMainFrame)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnUpdateCommands(CCmdUI* pCmdUI);
	afx_msg void OnSend();
	afx_msg void OnDevices();
	afx_msg void OnReceive();
	DECLARE_MESSAGE_MAP()
public:
	CMainFrame();
	virtual ~CMainFrame();
	BOOL IsReceiving() const
		{ return m_bReceiving; }
	BOOL CanPostResults() const
		{ return m_bPostResults; }
	BOOL ReportedEventStream() const
		{ return m_bReportedEventStream; }
	BOOL IsReceivingEvents() const
		{ return m_bReceivingEvents; }
	void PostResults();
	void ReportEventStream();
};
