// ---- midiout.cpp

#include "stdafx.h"
#include "midiout.h"

MidiOut::MidiOut()
{
    hMidiOut = 0;
	// ---- test for MIDI output devices
    numDevices = midiOutGetNumDevs();
	currDevice = -1;
}
MidiOut::~MidiOut()
{
	CloseDevice();
}
void MidiOut::CloseDevice()
{
	if (hMidiOut != 0)	{
		// --- close the device
		midiOutClose(hMidiOut);
		hMidiOut = 0;
	}
}
BOOL MidiOut::ChangeDevice(short int device)
{
	ASSERT(device < numDevices + 1);
	if (device != currDevice)	{
		CloseDevice();
		// --- open the new device
		HMIDIOUT hOut;
		if (midiOutOpen(&hOut, device, 0, 0L, 0L) != 0)	{
			currDevice = -1;
			return FALSE;
		}
		currDevice = device;
		hMidiOut = hOut;

	}
	return TRUE;
}
void MidiOut::StartMessage()
{
	if (hMidiOut != 0)	{
		DWORD mmsg  = 0xfa;
		midiOutShortMsg(hMidiOut, mmsg);
	}
}
void MidiOut::TimingMessage()
{
	if (hMidiOut != 0)	{
		DWORD mmsg  = 0xf8;
		midiOutShortMsg(hMidiOut, mmsg);
	}
}
void MidiOut::StopMessage()
{
	if (hMidiOut != 0)	{
		DWORD mmsg  = 0xfc;
		midiOutShortMsg(hMidiOut, mmsg);
	}
}
void MidiOut::DeviceList(CListBox* dlist)
{
	ASSERT(dlist != 0);
	MIDIOUTCAPS ocaps;
	for (short int i = 0; i < numDevices; i++)	{
		midiOutGetDevCaps(i, &ocaps, sizeof(ocaps));
		dlist->AddString(ocaps.szPname);
	}
}
