// ---- midoutdv.cpp

#include "stdafx.h"
#include "midoutdv.h"

midiOutDevice::midiOutDevice(int nChannel, int nPatch, MidiOut* pMidiOut) : 
			midiDevice(nChannel),
			m_nDefaultPatch(nPatch),
			m_pMidiOut(pMidiOut)
{
	Initialize();
}

void midiOutDevice::Initialize()
{
	midiDevice::Initialize();
	m_nPatch = 0;
	m_nVolume = 100;
	m_nPan = 64;
}
void midiOutDevice::NoteOn(int note, int velocity)
{
	DWORD dwEvent  = 0x90 | m_nChannel | (note << 8) | (velocity << 16);
	if (m_pMidiOut != 0)
		m_pMidiOut->SendEvent(dwEvent);
}
void midiOutDevice::NoteOff(int note, int velocity)
{
	DWORD dwEvent  = 0x80 | m_nChannel | (note << 8) | (velocity << 16);
	if (m_pMidiOut != 0)
		m_pMidiOut->SendEvent(dwEvent);
}
void midiOutDevice::ControllerChange(int controller, int velocity)
{
	if (m_pMidiOut != 0)	{
		DWORD dwEvent  = 0xB0 | m_nChannel | (controller << 8) | (velocity << 16);
		m_pMidiOut->SendEvent(dwEvent);
	}
}

